/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_MATERIAL_H_
#define MSP_GL_MATERIAL_H_

#include "color.h"

namespace Msp {
namespace GL {

class Material
{
private:
	Color ambient;
	Color diffuse;
	Color specular;
	Color emission;
	float shininess;

public:
	Material();
	void set_ambient(const Color &a);
	void set_diffuse(const Color &d);
	void set_specular(const Color &s);
	void set_emission(const Color &e);
	void set_shininess(float s);
	void apply() const;
};

} // namespace GL
} // namespace Msp

#endif
