/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#include "mesh.h"

using namespace std;

namespace Msp {
namespace GL {

Mesh::Mesh():
	vertices(NODATA)
{
	vertices.use_vertex_buffer();
}

Mesh::Mesh(VertexFormat f):
	vertices(f)
{
	vertices.use_vertex_buffer();
}

void Mesh::add_batch(const Batch &b)
{
	batches.push_back(b);
}

void Mesh::draw() const
{
	vertices.apply();
	for(list<Batch>::const_iterator i=batches.begin(); i!=batches.end(); ++i)
		i->draw();
}


Mesh::Loader::Loader(Mesh &m):
	mesh(m)
{
	add("vertices", &Loader::vertices);
	add("batch",    &Loader::batch);
}

void Mesh::Loader::vertices(VertexFormat f)
{
	mesh.vertices.reset(f);
	load_sub(mesh.vertices);
}

void Mesh::Loader::batch(PrimitiveType p)
{
	mesh.batches.push_back(Batch(p));
	load_sub(mesh.batches.back());
}

} // namespace GL
} // namespace Msp
