/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_OBJETCINSTANCE_H_
#define MSP_GL_OBJETCINSTANCE_H_

namespace Msp {
namespace GL {

class Object;
class ProgramData;

/**
Represents a single instance of an Object.  An application can derive another
class from this and overload the hook functions to specify location and other
instance-specific parameters for the rendered objects.
*/
class ObjectInstance
{
protected:
	const Object &object;

public:
	ObjectInstance(const Object &);
	void render() const;

	/**
	Hook function, called from Object just before rendering the mesh.
	*/
	virtual void setup_render() const { }

	/**
	Hook function, called from Object right after rendering the mesh.
	*/
	virtual void finish_render() const { }

	virtual unsigned get_detail_level() const { return 0; }
};

} // namespace GL
} // namespaec Msp

#endif
