/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_PROGRAMDATA_H_
#define MSP_GL_PROGRAMDATA_H_

#include <map>

namespace Msp {
namespace GL {

class Program;
class Uniform;

class ProgramData
{
private:
	std::map<int, Uniform *> data;

	ProgramData(const ProgramData &);
	ProgramData &operator=(const ProgramData &);
public:
	ProgramData();
	~ProgramData();

	void uniform(int, Uniform *);
	void uniform(int, int);
	void uniform(int, float);
	void uniform(int, float, float);
	void uniform2(int, const float *);
	void uniform(int, float, float, float);
	void uniform3(int, const float *);
	void uniform(int, float, float, float, float);
	void uniform4(int, const float *);
	void uniform_matrix4(int, const float *);
	void apply() const;
};

} // namespace GL
} // namespace Msp

#endif
