/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#ifndef MSP_GL_VERTEXFORMAT_H_
#define MSP_GL_VERTEXFORMAT_H_

#include <istream>
#include "types.h"

namespace Msp {
namespace GL {

enum VertexFormat
{
	NODATA=0,
	VERTEX2=1,
	VERTEX3,
	VERTEX4,
	NORMAL3=6,
	TEXCOORD1=8,
	TEXCOORD2,
	TEXCOORD3,
	TEXCOORD4,
	COLOR4_UBYTE=12,
	COLOR3_FLOAT=14,
	COLOR4_FLOAT,
};

inline VertexFormat operator,(VertexFormat a, VertexFormat b) { return VertexFormat(a<<4 | b); }
uint get_stride(VertexFormat);
std::istream &operator>>(std::istream &, VertexFormat &);

} // namespace GL
} // namespace Msp

#endif
